function [label, nValidSegmentation] = ml_randomSeg(len, nClass, lmin, lmax)
% function label = ml_randomSeg(len, nClass, lmin, lmax)
% Provides a truely random segmentation of a time series.
% Inputs:
%   len: the length of the time series.
%   nClass: number of classes.
%   lmin, lmax: the minimum and maximum lengths of each resulting segment. 
% Output:
%   label: 3*nSeg matrix label(:,i) is [start, end, label]' of segment i^th.
% Examples:
% By: Minh Hoai Nguyen (minhhoai@gmail.com)
% Date: 21 Sep 10

if (lmin < 1)
    error('lmin should be at least 1');
end;

if (lmin > lmax)
    error('lmin should not be greater than lmax');
end;

seed = randi(intmax);
[label, nValidSegmentation] = m_mexRandomSeg(len, nClass, lmin, lmax, seed);
if isinf(nValidSegmentation)
    error('# of valid semgnetation is infinity');
end;

    