#include "m_malloc.h"
#include "m_utils.h"
#include "m_BranchBound.cpp"
#include "m_TreeNode1.h"
#include "m_TreeNode1b.h"
#include "m_TreeNode1e.h"
#include "m_Multi1DSegs.h"


//void
//TreeNode1b_2::cmpBnds(){
//   Window smallestWin = winPair.getSmallestWin();
//   double *hist1_min = smallestWin.getPosNegScore(integralIms);
//   Window largestWin = winPair.getLargestWin();
//   double *hist1_max = largestWin.getPosNegScore(integralIms);
//
//   lb = hist1_min[1] - hist1_max[0];
//   ub = hist1_max[1] - hist1_max[0];
//
//   destroyVector<double>(hist1_min, 2);
//   destroyVector<double>(hist1_max, 2);
//}
//
////double ***TreeNode1b::integralIms = NULL;
//double ***TreeNode1b_2::integralIms = NULL;


double *Interval::integralIm = NULL;




void
Interval::findBestSubInt(){
   double newval;
   if (isChosen){ // find the maximum
      sL = -1; sU = -1; val = 0; //start with empty
      int mmin = l-1;
      for (int m = l; m <= u; m++){
         if (mmin == -1){
            newval = integralIm[m];
         } else {
            newval = integralIm[m] - integralIm[mmin];
         }
         if (newval > val){
            sL = mmin + 1;
            sU = m;
            val = newval;
         } else if (newval < 0){
            mmin = m; //keep track of the minimum element
         }
      }
   } else { // find the minimum
      sL = -1; sU = -1; val = 0; //start with empty
      int mmin = l-1;
      for (int m = l; m <= u; m++){
         if (mmin == -1){
            newval = -integralIm[m];
         } else {
            newval = -integralIm[m] + integralIm[mmin];
         }
         if (newval > val){
            sL = mmin + 1;
            sU = m;
            val = newval;
         } else if (newval < 0){
            mmin = m; //keep track of the minimum element
         }
      }
   }
   val = - val;
}

void
Interval::findBestSubInt2(){
   Window intWin(l, 0, u, 0);

   TreeNode1e rootNode(WindowPair(intWin, intWin));
   TreeNode1e bestNode = m_branch_bound<TreeNode1e>(rootNode, 0);
   Window bestWin = bestNode.ubWin;

   val = bestNode.ub;

   if (bestWin.ul_x > -1){ // the subinterval is not empty
      sL = bestWin.ul_x;
      sU = bestWin.lr_x;
   }
}

void
Interval::splitInt(Interval *left, Interval *right){
   //Left and right interval should never be empty.
   if (l < sL) {
      left->l = l;
      left->u = sL - 1;
      left->isChosen = isChosen;
   }
   if (sU < u){
      right->u = u;
      right->l = sU + 1;
      right->isChosen = isChosen;
   }
}

void
Multi1DSegs::copy(Multi1DSegs *newSegs){
   newSegs->nSeg   = nSeg;
   newSegs->energy = energy;
   newSegs->length = length;

   newSegs->segs = buildMatrix<double>(3, nSeg);
   for (int i=0; i < nSeg; i++){
      for (int j=0; j < 3; j++) newSegs->segs[j][i] = segs[j][i];
   }
};


Multi1DSegs::~Multi1DSegs(){
   //printf("Multi1DSegs destructor is called\n");
   destroyMatrix<double>(segs, 3, nSeg);
};

Multi1DSegs findMulti1DSegs_helper2(int & length, double ***& integralIms, int nSeg, double geVal)
{

   double *integralIm = buildVector<double>(length);
   for(int i = 0;i < length;i++){
      integralIm[i] = integralIms[0][i][0] - integralIms[0][i][1];
   }
   Interval::integralIm = integralIm;
   priority_queue<Interval,vector<Interval> ,IntervalCompare> myQ;
   priority_queue<Interval,vector<Interval> ,IntervalCompare> chosenQ;
   Interval topNode(0, length - 1, false);
   topNode.findBestSubInt();
   myQ.push(topNode);
   int nChosenSeg = 0;
   double E = 0;
   while(nChosenSeg < nSeg){
      if(myQ.empty())
         break;

      topNode = myQ.top();
      myQ.pop();
      if(topNode.val >= 0){
         if(topNode.isChosen){
            Window win(topNode.l, 0, topNode.u, 0);
            double *hist = win.getPosNegScore(integralIms);
            topNode.val = hist[0] - hist[1];
            destroyVector<double>(hist, 2);
            chosenQ.push(topNode);
         }
         break;
      }

      Interval middle(topNode.sL, topNode.sU, !topNode.isChosen);
      middle.findBestSubInt();
      myQ.push(middle);
      Interval left, right;
      topNode.splitInt(&left, &right);
      if(left.l > -1){
         left.findBestSubInt();
         myQ.push(left);
      }
      if(right.l > -1){
         right.findBestSubInt();
         myQ.push(right);
      }
      nChosenSeg++;
      E += topNode.val;
      if(E < geVal)
         break;

   }
   while(!myQ.empty()){
      topNode = myQ.top();
      myQ.pop();
      if(topNode.isChosen){
         Window win(topNode.l, 0, topNode.u, 0);
         double *hist = win.getPosNegScore(integralIms);
         topNode.val = hist[0] - hist[1];
         destroyVector<double>(hist, 2);
         chosenQ.push(topNode);
      }
   }

   int nChosen = chosenQ.size();
   double **chosenSegs = buildMatrix<double>(3, nChosen);
   int cnt = 0;
   int totalLength = 0;
   while(!chosenQ.empty()){
      topNode = chosenQ.top();
      chosenQ.pop();
      chosenSegs[0][cnt] = topNode.l;
      chosenSegs[1][cnt] = topNode.u;
      chosenSegs[2][cnt] = topNode.val;
      cnt++;
      totalLength += topNode.u - topNode.l + 1;
   }
   destroyVector<double>(integralIm, length);
   Multi1DSegs rslt(chosenSegs, nChosen, E, totalLength);
   return rslt;
}

double **findMulti1DSegs_helper(int & length, double ***& integralIms, int nSeg, int *nChosen)
{
   Window win(0, 0, length-1, 0);
   double *hist = win.getPosNegScore(integralIms);
   double geVal = -hist[1];
   destroyVector<double>(hist, 2);

   Multi1DSegs rslt = findMulti1DSegs_helper2(length, integralIms, nSeg, geVal);
   *nChosen = rslt.nSeg;
   double **segs = buildMatrix<double>(3, rslt.nSeg);

   for (int k=0; k < rslt.nSeg; k++)
      for (int r=0; r < 3; r++)
         segs[r][k] = rslt.segs[r][k];

   return segs;
}

double** findMulti1DSegs(int **kpAssign, int nKeyPnt, int imW,
                double *weights, int nHistBin, int nSeg, int *nChosen){

   double ***integralIms = cmpIntegralIms3(kpAssign, nKeyPnt, 1, imW, weights, nHistBin);
   double **chosenSegs = findMulti1DSegs_helper(imW, integralIms, nSeg, nChosen);
   destroyArrayThree<double>(integralIms, 1, imW, 2);

//   cout << "in findMulti1DSegs" << endl;
//   for (int k=0; k < *nChosen; k++){
//      cout << "[" << chosenSegs[0][k] << ", "
//      << chosenSegs[1][k] << "]; " ;
//   }
//   cout << endl;

   return chosenSegs;
}

double** findMulti1DSegs2(double *pixVals, int length, int nSeg, int *nChosen){

   double ***integralIms = cmpIntegralIms4(&pixVals, 1, length);
   double **chosenSegs = findMulti1DSegs_helper(length, integralIms, nSeg, nChosen);
   destroyArrayThree<double>(integralIms, 1, length, 2);
   return chosenSegs;
}


double **findMulti1DSegs_seq_helper(double ***& integralIms, SizeRange szRange, int & imW, int nSeg, double thres, int *nChosen)
{
    TreeNode1e::integralIms = integralIms;
    TreeNode1e::szRange = szRange;
    priority_queue<Interval,vector<Interval> ,IntervalCompare> myQ;
    priority_queue<Interval,vector<Interval> ,IntervalCompare> chosenQ;
    Interval topNode(0, imW - 1, false);
    topNode.findBestSubInt2();
    myQ.push(topNode);
    int nChosenSeg = 0;
    if(nSeg == -1)
        nSeg = imW;

    while(nChosenSeg < nSeg){
        if(myQ.empty())
            break;

        topNode = myQ.top();
        myQ.pop();
        if((topNode.val >= 0) || (topNode.val > thres)){
            break;
        }
        Interval middle(topNode.sL, topNode.sU);
        middle.findBestSubInt2();
        middle.val = topNode.val;
        chosenQ.push(middle);
        Interval left, right;
        topNode.splitInt(&left, &right);
        if((left.l > -1) && (left.u - left.l + 1 >= TreeNode1e::szRange.wmin)){
            left.findBestSubInt2();
            myQ.push(left);
        }
        if((right.l > -1) && (right.u - right.l + 1 >= TreeNode1e::szRange.wmin)){
            right.findBestSubInt2();
            myQ.push(right);
        }
        nChosenSeg++;
    }

    *nChosen = chosenQ.size();
    double **chosenSegs = buildMatrix<double>(3, *nChosen);
    int cnt = 0;
    while(!chosenQ.empty()){
        topNode = chosenQ.top();
        chosenQ.pop();
        chosenSegs[0][cnt] = topNode.l;
        chosenSegs[1][cnt] = topNode.u;
        chosenSegs[2][cnt] = topNode.val;
        cnt++;
    }
    return chosenSegs;
}

double** findMulti1DSegs_seq(int **kpAssign, int nKeyPnt, int imW, double *weights,
   int nHistBin, int nSeg, SizeRange szRange, double thres, int *nChosen){

   double ***integralIms = cmpIntegralIms3(kpAssign, nKeyPnt, 1, imW, weights, nHistBin);
   double **chosenSegs = findMulti1DSegs_seq_helper(integralIms, szRange, imW, nSeg, thres, nChosen);
   destroyArrayThree<double>(integralIms, 1, imW, 2);
   return chosenSegs;
}

double** findMulti1DSegs_seq2(double *pixVals, int imW, int nSeg,
      SizeRange szRange, double thres, int *nChosen){

   double ***integralIms = cmpIntegralIms4(&pixVals, 1, imW);
   double **chosenSegs = findMulti1DSegs_seq_helper(integralIms, szRange, imW, nSeg, thres, nChosen);
   destroyArrayThree<double>(integralIms, 1, imW, 2);
   return chosenSegs;
}





int **getTPFPsFor4allNSegs(double *pixVals, int length, bool *gtLabel){
   double ***integralIms = cmpIntegralIms4(&pixVals, 1, length);
   double *integralIm = buildVector<double>(length);
   for(int i = 0;i < length;i++){
      integralIm[i] = integralIms[0][i][0] - integralIms[0][i][1];
   }

   Interval::integralIm = integralIm;
   priority_queue<Interval,vector<Interval> ,IntervalCompare> myQ;
   Interval topNode(0, length - 1, false);
   topNode.findBestSubInt();
   myQ.push(topNode);
   int nChosenSeg = 0;

   bool *chosenIndVec = buildVector<bool>(length);
   int **nTPFP = buildMatrix<int>(2, length);
   int nTP = 0, nFP = 0; // # of true and false positive;

   while(nChosenSeg < length){
      if(myQ.empty())
         break;

      topNode = myQ.top();
      myQ.pop();
      //value of the subinterval
      if(topNode.val >= 0) break;

      Interval middle(topNode.sL, topNode.sU, !topNode.isChosen);
      //compute nTP and nFP
      for (int i= topNode.sL; i <= topNode.sU; i++) {
         chosenIndVec[i] = !topNode.isChosen;
         if (!topNode.isChosen){
            if (gtLabel[i]) nTP++;
            else nFP++;
         } else {
            if (gtLabel[i]) nTP--;
            else nFP--;
         }


      }
      nTPFP[0][nChosenSeg] = nTP;
      nTPFP[1][nChosenSeg] = nFP;

      middle.findBestSubInt();
      myQ.push(middle);
      Interval left, right;
      topNode.splitInt(&left, &right);
      if(left.l > -1){
         left.findBestSubInt();
         myQ.push(left);
      }
      if(right.l > -1){
         right.findBestSubInt();
         myQ.push(right);
      }
      nChosenSeg++;
   }


   if ((nTP + nFP) < length){
      priority_queue<Interval,vector<Interval> ,IntervalCompare> remIdxsQ;

      for (int i=0; i < length; i++){
         if (!chosenIndVec[i]){
            Interval remIdx = Interval(i,i);
            remIdx.val = pixVals[i];
            remIdxsQ.push(remIdx);
         }
      }
      //remove frame by frame because they are all positive
      while(!remIdxsQ.empty()){
          topNode = remIdxsQ.top();
          remIdxsQ.pop();
          int idx = topNode.l;
          if (gtLabel[idx]) nTP++;
          else nFP++;

          nTPFP[0][nChosenSeg] = nTP;
          nTPFP[1][nChosenSeg] = nFP;
          nChosenSeg++;
      }
   }

   //fill the remaining values
   for (int i=nChosenSeg; i< length; i++){
      nTPFP[0][i] = nTPFP[0][nChosenSeg-1];
      nTPFP[1][i] = nTPFP[1][nChosenSeg-1];
   }

   destroyArrayThree<double>(integralIms, 1, length, 2);
   destroyVector<double>(integralIm, length);
   destroyVector<bool>(chosenIndVec, length);

   return nTPFP;
}
