#include "m_malloc.h"
#include "m_utils.h"
#include "m_BranchBound.cpp"
#include "m_TreeNode1e.h"






void
TreeNode1e::cmpBnds(){
   Res xx, yy;

   if ((!findEnds(Res(winPair.win1.ul_x, winPair.win1.lr_x),
        Res(winPair.win2.ul_x, winPair.win2.lr_x),
        Res(szRange.wmin, szRange.wmax), &xx)) ||
      (!findEnds(Res(winPair.win1.ul_y, winPair.win1.lr_y),
        Res(winPair.win2.ul_y, winPair.win2.lr_y),
        Res(szRange.hmin, szRange.hmax), &yy))){

       lb = INF;
       ub = INF;
       return;
   }

   ubWin = Window(xx.x, yy.x, xx.y, yy.y);
   if ((ubWin.ul_x > ubWin.lr_x) ||
      (ubWin.ul_y > ubWin.lr_y)){
       ubWin = Window();
   }

   double *hist_ub = ubWin.getPosNegScore(integralIms);
   ub = hist_ub[0] - hist_ub[1];

   Window smallestWin = winPair.getSmallestWin();
   double *hist1_min = smallestWin.getPosNegScore(integralIms);
   Window largestWin = winPair.getLargestWin();
   double *hist1_max = largestWin.getPosNegScore(integralIms);

   lb = hist1_min[0] - hist1_max[1];

   destroyVector<double>(hist1_min, 2);
   destroyVector<double>(hist1_max, 2);
   destroyVector<double>(hist_ub, 2);
}


double ***TreeNode1e::integralIms = NULL;
SizeRange TreeNode1e::szRange;



TreeNode1e findBox1e_helper(int & imW, int & imH, SizeRange & szRange)
{
    Window biggestWin(0, 0, imW - 1, imH - 1);
    TreeNode1e rootNode(WindowPair(biggestWin, biggestWin));
    double tolFactor = 0;
    TreeNode1e::szRange = szRange;
    TreeNode1e bestNode = m_branch_bound<TreeNode1e>(rootNode, tolFactor);
    return bestNode;
}

Window findBox1e(int **kpAssign, int nKeyPnt, int imH, int imW,
                 double *weights, int nHistBin,
                 SizeRange szRange){
   double ***integralIms = cmpIntegralIms3(kpAssign, nKeyPnt, imH, imW, weights, nHistBin);
   TreeNode1e::integralIms = integralIms;
   TreeNode1e bestNode = findBox1e_helper(imW, imH, szRange);
   destroyArrayThree<double>(integralIms, imH, imW, 2);
   return bestNode.ubWin;
}

Window findBox1e2(double **pixVals, int imH, int imW, SizeRange szRange){
   double ***integralIms = cmpIntegralIms4(pixVals, imH, imW);
   TreeNode1e::integralIms = integralIms;
   TreeNode1e bestNode = findBox1e_helper(imW, imH, szRange);
   destroyArrayThree<double>(integralIms, imH, imW, 2);
   return bestNode.ubWin;
}

