#include "m_malloc.h"
#include "m_utils.h"
#include "m_BranchBound.cpp"
#include "m_TreeNode1h.h"


void
TreeNode1h::cmpBnds(){
   Res xx, yy;

   if ((!findEnds(Res(winPair.win1.ul_x, winPair.win1.lr_x),
        Res(winPair.win2.ul_x, winPair.win2.lr_x),
        Res(szRange.wmin, szRange.wmax), &xx)) ||
      (!findEnds(Res(winPair.win1.ul_y, winPair.win1.lr_y),
        Res(winPair.win2.ul_y, winPair.win2.lr_y),
        Res(szRange.hmin, szRange.hmax), &yy))){
      
       lb = INF;
       ub = INF;
       return;
   }

   ubWin = Window(xx.x, yy.x, xx.y, yy.y); 
   if ((ubWin.ul_x > ubWin.lr_x) ||
      (ubWin.ul_y > ubWin.lr_y)){
       ubWin = Window();
   } 

   double *hist_ub = ubWin.getPosNegScore(integralIms); 
   double *hist_ub_cnt = ubWin.getPosNegScore(cntIms);   
   ub = (hist_ub[0] - hist_ub[1])/(hist_ub_cnt[0] + EPS); 
   
   Window smallestWin = winPair.getSmallestWin();
   double *hist1_min = smallestWin.getPosNegScore(integralIms);
   double *hist1_min_cnt = smallestWin.getPosNegScore(cntIms);
   Window largestWin = winPair.getLargestWin();
   double *hist1_max = largestWin.getPosNegScore(integralIms);
   double *hist1_max_cnt = largestWin.getPosNegScore(cntIms);

   lb = hist1_min[0] - hist1_max[1];
   if (lb > 0) lb = lb/(hist1_max_cnt[0] + EPS);
   else        lb = lb/(hist1_min_cnt[0] + EPS);
 
   destroyVector<double>(hist1_min, 2);
   destroyVector<double>(hist1_max, 2);
   destroyVector<double>(hist_ub, 2);
   destroyVector<double>(hist_ub_cnt, 2);
   destroyVector<double>(hist1_min_cnt, 2);
   destroyVector<double>(hist1_max_cnt, 2);
}


double ***TreeNode1h::integralIms = NULL;
double ***TreeNode1h::cntIms = NULL;
SizeRange TreeNode1h::szRange;


Window findBox1h(int **kpAssign, int nKeyPnt, int imH, int imW, 
                 double *weights, int nHistBin,
                 SizeRange szRange){   
   double ***integralIms = cmpIntegralIms3(kpAssign, nKeyPnt, imH, imW, weights, nHistBin);
   double *ones = buildVector<double>(nHistBin);
   for (int i=0; i< nHistBin; i++) ones[i] = 1;   
   double ***cntIms = cmpIntegralIms3(kpAssign, nKeyPnt, imH, imW, ones, nHistBin);
   

   Window biggestWin(0,0, imW-1, imH-1);
   TreeNode1h rootNode(WindowPair(biggestWin, biggestWin));
   double tolFactor = EPS;
   
   TreeNode1h::integralIms = integralIms;   
   TreeNode1h::cntIms = cntIms;
   TreeNode1h::szRange = szRange;

   TreeNode1h bestNode = m_branch_bound<TreeNode1h>(rootNode, tolFactor);
   destroyArrayThree<double>(integralIms, imH, imW, 2);   
   destroyArrayThree<double>(cntIms, imH, imW, 2);  
   destroyVector<double>(ones, nHistBin);
   return bestNode.ubWin; 
}
