#include <iostream>
#include <cmath>
#include <queue>
#include <string>
#include <sstream>
#include <fstream>
#include "m_utils.h"
#include "m_malloc.h"
#include "m_TreeNode1h.h"
#include "m_BranchBound.cpp"
#include "m_tests.h"

void test1h_1(){
   int imH1 = 3;
   int imW1 = 4;
   
   int nHistBin = 2;
   int nTest = 13;
   double ones[] = {1, 1};

   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   double **weights = buildMatrix<double>(nTest, 2); 
   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];
   
   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,2);
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 1;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 2;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,1,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   weights[i][0] = 1; weights[i][1] = -0.1;


   i = 3;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,1,2);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 4;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 3);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 5;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,3,2);
   szRanges[i] = SizeRange(2, 2, 2, 3);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 6;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(0, 2, 2, 3);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 7;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(2, 2, 2, 2);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 8;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,1,2);
   szRanges[i] = SizeRange(2, 2, 1, 1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 9;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,0,2,0);
   szRanges[i] = SizeRange(1, 1, 2, 2);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 10;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,2, 3,2);
   szRanges[i] = SizeRange(1, 1, 2, 3);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 11;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(-1,-1,-1,-1);
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;

   i = 12;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(2,1,3,1);
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = -2;

   int **im1 = buildMatrix<int>(imH1, imW1);
            
   for (int k= 0; k < nTest; k++){
      cout << "==============Testing test1e_1." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }      
         cout << endl;
      }      	
      
      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1); 
      Window bestBBox = findBox1h(kpAssign1, imH1*imW1, imH1, imW1, weights[k], nHistBin, szRanges[k]);


      double ***integralIms1 = 
	 cmpIntegralIms3(kpAssign1, imH1*imW1, imH1, imW1, weights[k], nHistBin);
      double ***cntIms = 
	 cmpIntegralIms3(kpAssign1, imH1*imW1, imH1, imW1, ones, nHistBin);


      double *hist1_best = bestBBox.getPosNegScore(integralIms1); 
      double *hist1_best_cnt = bestBBox.getPosNegScore(cntIms);
      double energy_best = (hist1_best[0] - hist1_best[1])/(hist1_best_cnt[0] + EPS); 

      cout << "Best window " << bestBBox.str()  
           << ", energy: " << energy_best << endl;      

      double *hist1_exp = expBBoxes[k].getPosNegScore(integralIms1); 
      double *hist1_exp_cnt = expBBoxes[k].getPosNegScore(cntIms);
      double energy_exp = (hist1_exp[0] - hist1_exp[1])/(hist1_exp_cnt[0] + EPS); 

      if (energy_best < energy_exp - EPS){
         cout << "WARNING: expected energy is bigger than returned energy" << endl;
      } else if (energy_best > energy_exp + EPS){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << endl;
	 cout << "        expected energy: " << energy_exp << endl;
      } else {
         cout << "PASSED" << endl;
      }
            
      destroyMatrix<int>(kpAssign1, imH1*imW1,3);
      destroyArrayThree<double>(integralIms1, imH1, imW1, 2);
      destroyArrayThree<double>(cntIms, imH1, imW1, 2);
      destroyVector<double>(hist1_best, 2);
      destroyVector<double>(hist1_exp, 2);
      destroyVector<double>(hist1_exp_cnt, 2);
      destroyVector<double>(hist1_best_cnt, 2);
      cout << endl; 
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);   
   destroyMatrix<int>(im1, imH1, imW1);
   delete [] expBBoxes;
   delete [] szRanges;
   destroyMatrix<double>(weights, nTest, 2);
}