/*
 * m_TreeNode1i.h
 *
 *  Created on: May 8, 2009
 *      Author: hoai
 */

#ifndef M_TREENODE1I_H_
#define M_TREENODE1I_H_

#include "m_TreeNode1.h"

class TreeNode1i:public TreeNode1{
public:
   static int ***integralIms;
   static SizeRange szRange;
   static double *weights;
   static double C;
   static int *hist_target;
   static int nHistBin;

   // return sum_i {weights(i)*|hist(i) - hist_target(i)|^2} - C*area(window)
   static double cmpEnergy(int* hist, int* target, double *weights, int nHistBin,
         Window win, double C);


   Window ubWin;

   TreeNode1i(WindowPair winPair_):TreeNode1(winPair_){};
   TreeNode1i():TreeNode1(){};
   void cmpBnds();
};

/**
 * Find the best rectangular window in an image that minimizes:
 *    sum_i {weights(i)*|hist(i) - hist_target(i)|^2} - C*area(window)
 * Inputs:
 *    kpAssign: a 2-dim array of size nKeyPnt*3 for histogram bin assignments.
 *    kpAssign[i][0], kpAssign[i][1], kpAssign[i][2] are row#, col#, bin#
 *       entries are positive integers.
 *    nKeyPnt: # of keypoints.
 *    imH, imW: height and width of the image
 *    weights: a 1-dim array for weights for histogram bins
 *    nHistBin: # of histogram bins
 *    hist_target: target histogram
 *    C: parameter for trade off between perfect histogram matching and large window.
 *    szRange: range for the width and height of the box.
 *    tolFac: tolerance factor for stopping
 * Output:
 *    A best rectangle that minimizes the desired energy
 */
Window findBox1i(int **kpAssign, int nKeyPnt, int imH, int imW, double *weights, int nHistBin,
		int *hist_target, double C, SizeRange szRange, double tolFac);



#endif /* M_TREENODE1I_H_ */
