/*
 * m_TreeNode1i_tests.cpp
 *
 *  Created on: May 9, 2009
 *  Author: Minh Hoai Nguyen (minhhoai@gmail.com)
 */

#include <iostream>
#include <cmath>
#include <queue>
#include <string>
#include <sstream>
#include <fstream>
#include "m_utils.h"
#include "m_malloc.h"
#include "m_TreeNode1i.h"
#include "m_BranchBound.cpp"
#include "m_tests.h"


void test1i_1(){
   int imH = 3;
   int imW = 4;

   int nHistBin = 2;
   int nTest = 10;

   int ***imAssign = buildArrayThree<int>(imH, imW, nTest);
   double **weights = buildMatrix<double>(nTest, nHistBin);
   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];
   int **hist_targets = buildMatrix<int>(nTest, nHistBin);
   double *Cs = buildVector<double>(nTest);


   int i = 0;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 2; hist_targets[i][1] = 2;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 0;
   expBBoxes[i] = Window(0,0,1,1);

   i = 1;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 2; hist_targets[i][1] = 3;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 0;
   expBBoxes[i] = Window(0,0,2,1);

   i = 2;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 3; hist_targets[i][1] = 3;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 0;
   expBBoxes[i] = Window(0,0,1,2);

   i = 3;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 3; hist_targets[i][1] = 4;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 0;
   expBBoxes[i] = Window(0,0,1,2);

   i = 4;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 3; hist_targets[i][1] = 4;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 3;
   expBBoxes[i] = Window(0,0,2,2);

   i = 5;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 3; hist_targets[i][1] = 4;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 5;
   expBBoxes[i] = Window(0,0,3,2);

   i = 6;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 3; hist_targets[i][1] = 4;
   szRanges[i] = SizeRange(0, 2, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 5;
   expBBoxes[i] = Window(0,0,3,1);

   i = 7;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 0; hist_targets[i][1] = 6;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 3;
   expBBoxes[i] = Window(0,0,2,2);

   i = 8;
   imAssign[0][0][i] = 1; imAssign[1][0][i] = 1; imAssign[2][0][i] = 1;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 1; imAssign[1][3][i] = 1; imAssign[2][3][i] = 1;

   hist_targets[i][0] = 0; hist_targets[i][1] = 6;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 10;
   expBBoxes[i] = Window(0,0,3,2);

   i = 9;
   imAssign[0][0][i] = 2; imAssign[1][0][i] = 2; imAssign[2][0][i] = 2;
   imAssign[0][1][i] = 2; imAssign[1][1][i] = 2; imAssign[2][1][i] = 2;
   imAssign[0][2][i] = 2; imAssign[1][2][i] = 2; imAssign[2][2][i] = 2;
   imAssign[0][3][i] = 2; imAssign[1][3][i] = 2; imAssign[2][3][i] = 2;

   hist_targets[i][0] = 0; hist_targets[i][1] = 0;
   szRanges[i] = SizeRange(0, 3, 0, 4);
   weights[i][0] = 1; weights[i][1] = 1;
   Cs[i] = 10;
   expBBoxes[i] = Window(0,0,2,1);


   int **im = buildMatrix<int>(imH, imW);

   for (int k= 0; k < nTest; k++){
      cout << "==============Testing test1i_1." << k << endl;
      cout << "image: " << endl;
      for (int i = 0; i< imH; i++){
         for (int j= 0; j < imW; j++){
            im[i][j] = imAssign[i][j][k];
            printf("%2d ", im[i][j]);
         }
         cout << endl;
      }
      cout << "Target hist: ";
      for (int i=0; i < nHistBin; i++){
         cout << hist_targets[k][i] << " ";
      }
      cout << endl;


      int ***integralIms1 = cmpIntegralIms(im, imH, imW, nHistBin);

      int** kpAssign1 = imAssign2kpAssign(im, imH, imW);
      Window bestBBox = findBox1i(kpAssign1, imH*imW, imH, imW, weights[k],
            nHistBin, hist_targets[k], Cs[k], szRanges[k], 0);

      int *hist1_best = bestBBox.getHist(integralIms1, nHistBin);
      double energy_best = TreeNode1i::cmpEnergy(hist1_best, hist_targets[k],
            weights[k], nHistBin, bestBBox, Cs[k]);

      cout << "Best window " << bestBBox.str()
           << ", energy: " << energy_best << endl;

      int *hist1_exp = expBBoxes[k].getHist(integralIms1, nHistBin);
      double energy_exp = TreeNode1i::cmpEnergy(hist1_exp, hist_targets[k],
            weights[k], nHistBin, expBBoxes[k], Cs[k]);

      if (energy_best < energy_exp){
         cout << "WARNING: expected energy " << energy_exp
              << " is bigger than returned energy " << energy_best << endl;
      } else if (energy_best > energy_exp){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << endl;
      } else {
         cout << "PASSED" << endl;
      }
      destroyArrayThree<int>(integralIms1, imH, imW, nHistBin);
      destroyVector<int>(hist1_best, nHistBin);
      destroyVector<int>(hist1_exp, nHistBin);
      destroyMatrix<int>(kpAssign1, imH*imW, 3);
      cout << endl;
   }


   destroyArrayThree<int>(imAssign, imH, imW, nTest);
   destroyMatrix<int>(im, imH, imW);
   destroyMatrix<double>(weights, nTest, nHistBin);
   destroyMatrix<int>(hist_targets, nTest, nHistBin);
   destroyVector<double>(Cs, nTest);
   delete [] expBBoxes;
   delete [] szRanges;

}
