#ifndef M_TREENODE2B_H
#define M_TREENODE2B_H



/**
 *
 */
class TreeNode2b{
public:
   static int ***integralIms1, imH1, imW1, ***integralIms2, imH2, imW2, nHistBin;
   static double *weights, C;
   static Res winRes1, winRes2;


   double lb, ub;
   Window win1, win2;
   WindowPair bestBoxes;
   SizeRange szRange;
   bool isEmpty;

   void cmpBnds();
   TreeNode2b(Window win1_, Window win2_, SizeRange szRange_):
      win1(win1_),win2(win2_), szRange(szRange_){};
   TreeNode2b(){};
   void split(TreeNode2b *left, TreeNode2b *right);
   // refine the parameter space by croping the rectangle for uper left corners
   // or by limiting the size of the rectangles.
   void refine();
   string str();
protected:
   Window getIntersection(Window win, SizeRange szRange);
   Window getUnion(Window win, SizeRange szRange, int imH, int imW);
   int *getMinHist(int ***integralIm, int nHistBin, Window win, Res winRes);
   int *getMaxHist(int ***integralIm, int nHistBin, Window win, int imH, int imW, Res winRes);

};


/**
 * Simultaneously find same-sized rectangles in two images that have similar
 *    histograms by minimizing the objective:
 *    \f$ \sum_i {w_i[|h^1_i - h^2_i| - C(h^1_i + h^2_i)]}\f$
 * \param imAssign1, imAssign2: a 2 dim array for histogram bin assignments, entries should be
 *       positive integers.
 * \param imH1, imW1, imH2, imW2: height and width of the images
 * \param weights: a 1-dim array for weights for histogram bins
 * \param nHistBin: # of histogram bins
 * \param C: tradeoff b/t having good match to the target histogram and the size of the box
 * \param tolFactor: tolerance factor for stopping criteria of branch and bound
 *       if tolFactor = 0, run BB until global optimality is known.
 *       the bigger tolFactor, the earlier BB terminates.
 * \param knownBest: the solution is known to be better than this value.
 *       branches with the lower bound less than this value is not explored.
 *       if no leaf node has energy smaller than this value, the method
 *       return an arbitrary solution.
 * \param winRes1, winRes2: resolutions of grid search in image 1 and 2
 * \return Best (within tolerance) same-sized rectangles that minimizes the desired energy
 */
WindowPair findBoxes2b(int **imAssign1, int imH1, int imW1,
          int **imAssign2, int imH2, int imW2,
          double *weights, int nHistBin,
          double C, double tolFactor, double knownBest,
          Res winRes1 = Res(), Res winRes2 = Res());

#endif
