#include <iostream>
#include <cmath>
#include <queue>
#include <string>
#include <sstream>
#include <fstream>
#include "m_utils.h"
#include "m_malloc.h"
#include "m_Multi1DSegs.h"
#include "m_BranchBound.cpp"
#include "m_tests.h"


void testCmpIntegralIm3(){
   int imH1 = 3;
   int imW1 = 4;
   
   int nHistBin = 2;
   int nTest = 5;

   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   double weights[] = {10, -1};
      
   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   i = 1;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   i = 2;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   i = 3;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   i = 4;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   int **im1 = buildMatrix<int>(imH1, imW1);
   int **kpAssign = buildMatrix<int>(imH1*imW1, 3);
            
   for (int k= 0; k < nTest; k++){      
      cout << "==============Testing testCmpIntegralIms3." << k << endl;
      cout << "image 1: " << endl;

      int cnt = 0;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
            kpAssign[cnt][0] = i + 1;
            kpAssign[cnt][1] = j + 1;
            kpAssign[cnt][2] = im1[i][j];
            cnt++;
         }      
         cout << endl;
      }

      double ***integralIms2 = cmpIntegralIms2(im1, imH1, imW1, weights, nHistBin);
      double ***integralIms3 = cmpIntegralIms3(kpAssign, imH1*imW1, imH1, imW1, weights, nHistBin);
      
      
      bool isFail = false;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            if ((abs(integralIms2[i][j][0] - integralIms3[i][j][0]) +
               abs(integralIms2[i][j][1] - integralIms3[i][j][1])) > EPS){
                 isFail = true;
            }
         }     
         
      }      

      
      if (isFail){ 
         cout << "FAILED" << endl;
      } else {
         cout << "PASSED" << endl;
      }
      destroyArrayThree<double>(integralIms2, imH1, imW1, 2);
      destroyArrayThree<double>(integralIms3, imH1, imW1, 2);
      cout << endl;
   }
   destroyMatrix<int>(kpAssign, imH1*imW1, 3);      
   destroyMatrix<int>(im1, imH1, imW1);
   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
}
